import { DownloadOptions } from './lib/types';
export { DownloadOptions };
declare type Download = {
    (url: string, options?: DownloadOptions): Promise<void>;
    (options: DownloadOptions): Promise<void>;
};
/**
 * Downloads a GitHub project source code, but only the code without the .git data.
 *
 * @param {string} [url] - The url of the GitHub repository (add #<branch> at the end to specify the branch).
 * @param {DownloadOptions} [options] - The options for the download command.
 * @returns {Promise<void>} Returns nothing. The files will be saved in the disk or the function will throw an error.
 */
declare const download: Download;
export { download };
