import { DownloadOptions } from './types';
/**
 * Builds the URL that will be used to download the source code.
 *
 * @param {string} [url] - The url of the GitHub repository (add #<branch> at the end to specify the branch).
 * @param {DownloadOptions} [options] - The options for the download command.
 * @returns {Promise<string>} Returns a valid URL.
 */
export declare const buildUrl: (url?: string | undefined, options?: DownloadOptions | undefined) => Promise<string>;
