"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeOutput = void 0;
var decompress = require("decompress");
var fs = require("fs");
var path = require("path");
var error_1 = require("./error");
var fs_utils_1 = require("./fs-utils");
/**
 * Writes the output to disk
 *
 * @param {any} data - The result of the Ajax request.
 * @param {string} filename - The filename.
 * @returns {Promise<void>} Returns nothing if success, but throws if it fails.
 */
exports.writeOutput = function (data, filename) { return __awaiter(void 0, void 0, void 0, function () {
    var needsUnzip_1, writer_1, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                filename = path.resolve('./', filename);
                return [4 /*yield*/, createDirIfNecessary(filename)];
            case 1:
                _a.sent();
                needsUnzip_1 = false;
                if (!filename.endsWith('.zip')) {
                    filename += '/file.zip'; // temporary file
                    needsUnzip_1 = true;
                }
                writer_1 = fs.createWriteStream(filename);
                data.pipe(writer_1);
                return [4 /*yield*/, new Promise(function (resolve, reject) {
                        writer_1.on('finish', function () { return __awaiter(void 0, void 0, void 0, function () {
                            var parentFolder;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!needsUnzip_1) return [3 /*break*/, 3];
                                        parentFolder = path.join(path.dirname(filename), '..');
                                        return [4 /*yield*/, decompress(filename, parentFolder)];
                                    case 1:
                                        _a.sent();
                                        return [4 /*yield*/, fs.promises.unlink(filename)];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        resolve();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        writer_1.on('error', reject);
                    })];
            case 2:
                _a.sent();
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                error_1.addErrMsg(err_1, 'could not write the downloaded files to the local disk.');
                throw err_1;
            case 4: return [2 /*return*/];
        }
    });
}); };
var createDirIfNecessary = function (filename) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fs_utils_1.exist(filename)];
            case 1:
                if (_a.sent()) {
                    return [2 /*return*/];
                }
                if (!filename.endsWith('.zip')) return [3 /*break*/, 3];
                return [4 /*yield*/, fs.promises.mkdir(path.dirname(filename), { recursive: true })];
            case 2:
                _a.sent();
                return [3 /*break*/, 5];
            case 3: return [4 /*yield*/, fs.promises.mkdir(filename, { recursive: true })];
            case 4:
                _a.sent();
                _a.label = 5;
            case 5: return [2 /*return*/];
        }
    });
}); };
